#include <stdio.h>
/* Globals */

unsigned char *asmsrc1;
unsigned char *asmsrc2;
unsigned char *asmdst;
unsigned int asmnum1;
unsigned int asmnum2;
unsigned int asmnum3;

/* assembly routines */

extern void mmx_absdiff(void); 
extern void mmx_memcpy(void);
extern void mmx_blit(void);

void mmxcopy(unsigned char *src1, unsigned char *dst, unsigned int size) {
  asmsrc1 = src1;
  asmdst = dst;
  asmnum1 = size;

  mmx_memcpy();
}

void mmxblit(unsigned char *src1, unsigned char *dst, unsigned int height, unsigned int pitch, unsigned int scr_pitch) {
  asmsrc1 = src1;
  asmdst = dst;
  asmnum1 = height;
  asmnum2 = pitch;
  asmnum3 = scr_pitch;

  mmx_blit();
}

void mmxdiff(unsigned char *src1, unsigned char *src2, unsigned char *dst, unsigned int size) {
  unsigned char *tmp = dst;
  tmp += size;
  asmsrc1    = src1;
  asmsrc2    = src2;
  asmdst     = dst;
  asmnum1 = size;
  
  mmx_absdiff();
}
