#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include "strobe.h"

Strobe::Strobe() {
  initialized = false;
  storebuf = NULL;
  frame_count = 0;
  delay = 15; /* default delay */
}

Strobe::~Strobe() {
  cerr << "-- Strobe::~Strobe\n";
  if(storebuf!=NULL) {
    fprintf(stderr,"   unmapping buffer[0x%x]\n",(unsigned int)storebuf);
    free(storebuf);
  }
}

bool Strobe::init() {
  cerr << "-- Strobe::init\n";

  storebuf = (unsigned char*)malloc(*size);

  if(storebuf==NULL)
    return(false);
  
  fprintf(stderr,"  allocated storebuf[0x%x] sized[%u]\n",(unsigned int)storebuf,*size);
  return(true);
}

unsigned char *Strobe::process(unsigned char *buffo) {
  frame_count++;

  if(frame_count>delay) {
    memcpy(storebuf,buffo,*size);
    frame_count = 0;
  }

  return(storebuf);
}

void Strobe::set_delay(int num) {
  delay = num;
  frame_count = 0;
}
